"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _formik = require("formik");

var _size2 = _interopRequireDefault(require("lodash/size"));

var _flow2 = _interopRequireDefault(require("lodash/fp/flow"));

var _tap2 = _interopRequireDefault(require("lodash/fp/tap"));

var _Summary = _interopRequireDefault(require("../Summary"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var displayName = 'Form';
var defaultProps = {
  summary: true
};
var originalPageTitle = document.title;

var setDocumentTitle = function setDocumentTitle(_ref) {
  var errors = _ref.errors;
  var count = (0, _size2.default)(errors);
  document.title = count > 0 ? "(".concat(count, " errors) ").concat(originalPageTitle) : originalPageTitle;
};

var validate = function validate(validator) {
  return validator && (0, _flow2.default)(validator, (0, _tap2.default)(function (errors) {
    return setDocumentTitle({
      errors: errors
    });
  }));
};

var Form = function Form(props) {
  return _react.default.createElement(_formik.Formik, {
    initialValues: props.initialValues,
    onSubmit: props.onSubmit,
    render: (0, _flow2.default)((0, _tap2.default)(setDocumentTitle), function (formik) {
      return _react.default.createElement("form", {
        noValidate: true,
        onSubmit: formik.handleSubmit
      }, (0, _size2.default)(formik.errors) > 0 && props.summary && _react.default.createElement(_Summary.default, {
        errors: formik.errors
      }), props.children);
    }),
    validate: validate(props.validate),
    validateOnBlur: false,
    validateOnChange: false,
    validationSchema: props.validationSchema
  });
};

Form.displayName = displayName;
Form.defaultProps = defaultProps;
var _default = Form;
exports.default = _default;